Index: /extensions/UserAdvManager/trunk/include/functions.inc.php
===================================================================
--- /extensions/UserAdvManager/trunk/include/functions.inc.php	(revision 21074)
+++ /extensions/UserAdvManager/trunk/include/functions.inc.php	(revision 21075)
@@ -1497,15 +1497,15 @@
         $replacements[] = get_gallery_home_url();
 
-        if (isset($conf_UAM_ConfirmMail[0]) and $conf_UAM_ConfirmMail[0] == 'true') // [Kdays] replacement only if related option is active
+        if (isset($conf_UAM_ConfirmMail['CONFIRMMAIL_TIMEOUT']) and $conf_UAM_ConfirmMail['CONFIRMMAIL_TIMEOUT'] == 'true') // [Kdays] replacement only if related option is active
         {
           $patterns[] = '#\[Kdays\]#i';
-          $replacements[] = $conf_UAM_ConfirmMail[1];
+          $replacements[] = $conf_UAM_ConfirmMail['CONFIRMMAIL_DELAY'];
         }
 
         if (function_exists('get_user_language_desc'))
         {
-          $infos1 = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail[2]))."\n\n";
-        }
-				else $infos1 = l10n(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail[2]))."\n\n";
+          $infos1 = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail['CONFIRMMAIL_REMAIL_TXT1']))."\n\n";
+        }
+				else $infos1 = l10n(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail['CONFIRMMAIL_REMAIL_TXT1']))."\n\n";
 
         $infos2 = array
@@ -1528,5 +1528,5 @@
 
     case 2: //Generating email content for remind without a new key
-      if (isset($conf_UAM[42]) and !empty($conf_UAM[42]))
+      if (isset($conf_UAM['CONFIRMMAIL_REMAIL_SUBJECT']) and !empty($conf_UAM['CONFIRMMAIL_REMAIL_SUBJECT']))
       {
         // Management of Extension flags ([username], [mygallery])
@@ -1539,10 +1539,10 @@
         if (function_exists('get_user_language_desc'))
         {
-          $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[42]))."\n\n";
-        }
-        else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM[42]))."\n\n"; 
-      }
-
-      if (isset($conf_UAM_ConfirmMail[4]) and !empty($conf_UAM_ConfirmMail[4]) and isset($conf_UAM_ConfirmMail[3]) and $conf_UAM_ConfirmMail[3] == 'true' and !$confirm)
+          $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['CONFIRMMAIL_REMAIL_SUBJECT']))."\n\n";
+        }
+        else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM['CONFIRMMAIL_REMAIL_SUBJECT']))."\n\n"; 
+      }
+
+      if (isset($conf_UAM_ConfirmMail['CONFIRMMAIL_REMAIL_TXT2']) and !empty($conf_UAM_ConfirmMail['CONFIRMMAIL_REMAIL_TXT2']) and isset($conf_UAM_ConfirmMail['CONFIRMMAIL_REMAIL']) and $conf_UAM_ConfirmMail['CONFIRMMAIL_REMAIL'] == 'true' and !$confirm)
       {
         // Management of Extension flags ([username], [mygallery], [myurl], [Kdays])
@@ -1555,15 +1555,15 @@
         $replacements[] = get_gallery_home_url();
 
-        if (isset($conf_UAM_ConfirmMail[0]) and $conf_UAM_ConfirmMail[0] == 'true') // [Kdays] replacement only if related option is active
+        if (isset($conf_UAM_ConfirmMail['CONFIRMMAIL_TIMEOUT']) and $conf_UAM_ConfirmMail['CONFIRMMAIL_TIMEOUT'] == 'true') // [Kdays] replacement only if related option is active
         {
           $patterns[] = '#\[Kdays\]#i';
-          $replacements[] = $conf_UAM_ConfirmMail[1];
+          $replacements[] = $conf_UAM_ConfirmMail['CONFIRMMAIL_DELAY'];
         }
 
         if (function_exists('get_user_language_desc'))
         {
-          $infos1 = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail[4]))."\n\n";
-        }
-        else $infos1 = l10n(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail[4]))."\n\n";
+          $infos1 = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail['CONFIRMMAIL_REMAIL_TXT2']))."\n\n";
+        }
+        else $infos1 = l10n(preg_replace($patterns, $replacements, $conf_UAM_ConfirmMail['CONFIRMMAIL_REMAIL_TXT2']))."\n\n";
       }
 
@@ -1622,5 +1622,5 @@
   load_language('plugin.lang', UAM_PATH);
 
-  if (isset($conf_UAM[45]) and !empty($conf_UAM[45]))
+  if (isset($conf_UAM['GTREMINDER_SUBJECT']) and !empty($conf_UAM['GTREMINDER_SUBJECT']))
   {
     // Management of Extension flags ([username], [mygallery])
@@ -1633,10 +1633,10 @@
     if (function_exists('get_user_language_desc'))
     {
-      $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[45]))."\n\n";
-    }
-    else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM[45]))."\n\n"; 
-  }
-
-  if (isset($conf_UAM[17]) and !empty($conf_UAM[17]) and isset($conf_UAM[15]) and $conf_UAM[15] == 'true')
+      $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['GTREMINDER_SUBJECT']))."\n\n";
+    }
+    else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM['GTREMINDER_SUBJECT']))."\n\n"; 
+  }
+
+  if (isset($conf_UAM['GHOSTRACKER_REMINDERTEXT']) and !empty($conf_UAM['GHOSTRACKER_REMINDERTEXT']) and isset($conf_UAM['GHOSTRACKER']) and $conf_UAM['GHOSTRACKER'] == 'true')
   {
     // Management of Extension flags ([username], [mygallery], [myurl], [days])
@@ -1649,13 +1649,13 @@
     $replacements[] = get_gallery_home_url();
     $patterns[] = '#\[days\]#i';
-    $replacements[] = $conf_UAM[16];
+    $replacements[] = $conf_UAM['GHOSTRACKER_DAYLIMIT'];
 
     if (function_exists('get_user_language_desc'))
     {
-      $infos1 = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[17]))."\n\n";
+      $infos1 = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['GHOSTRACKER_REMINDERTEXT']))."\n\n";
     }
     else
     {
-      $infos1 = l10n(preg_replace($patterns, $replacements, $conf_UAM[17]))."\n\n";
+      $infos1 = l10n(preg_replace($patterns, $replacements, $conf_UAM['GHOSTRACKER_REMINDERTEXT']))."\n\n";
     }
 
@@ -1719,5 +1719,5 @@
   }
 
-  if (isset($conf_UAM[44]) and !empty($conf_UAM[44]))
+  if (isset($conf_UAM['GTAUTOMAIL_SUBJECT']) and !empty($conf_UAM['GTAUTOMAIL_SUBJECT']))
   {
     // Management of Extension flags ([username], [mygallery])
@@ -1730,10 +1730,10 @@
     if (function_exists('get_user_language_desc'))
     {
-      $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[44]))."\n\n";
-    }
-    else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM[44]))."\n\n"; 
-  }
-
-  if (isset($conf_UAM[24]) and !empty($conf_UAM[24]))
+      $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['GTAUTOMAIL_SUBJECT']))."\n\n";
+    }
+    else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM['GTAUTOMAIL_SUBJECT']))."\n\n"; 
+  }
+
+  if (isset($conf_UAM['GTAUTOMAILTEXT']) and !empty($conf_UAM['GTAUTOMAILTEXT']))
   {
     // Management of Extension flags ([username], [mygallery], [myurl])
@@ -1748,7 +1748,7 @@
     if (function_exists('get_user_language_desc'))
     {
-      $custom_txt = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[24]))."\n\n";
-    }
-    else $custom_txt = l10n(preg_replace($patterns, $replacements, $conf_UAM[24]))."\n\n"; 
+      $custom_txt = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['GTAUTOMAILTEXT']))."\n\n";
+    }
+    else $custom_txt = l10n(preg_replace($patterns, $replacements, $conf_UAM['GTAUTOMAILTEXT']))."\n\n"; 
   }
 
@@ -1835,5 +1835,5 @@
   $result = pwg_db_fetch_assoc(pwg_query($query));
 
-  if (isset($conf_UAM[46]) and !empty($conf_UAM[46]))
+  if (isset($conf_UAM['ADMINVALIDATIONMAIL_SUBJECT']) and !empty($conf_UAM['ADMINVALIDATIONMAIL_SUBJECT']))
   {
     // Management of Extension flags ([username], [mygallery])
@@ -1846,10 +1846,10 @@
     if (function_exists('get_user_language_desc'))
     {
-      $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[46]))."\n\n";
-    }
-    else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM[46]))."\n\n";
-  }
-
-  if (isset($conf_UAM[27]) and !empty($conf_UAM[27]))
+      $subject = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['ADMINVALIDATIONMAIL_SUBJECT']))."\n\n";
+    }
+    else $subject = l10n(preg_replace($patterns, $replacements, $conf_UAM['ADMINVALIDATIONMAIL_SUBJECT']))."\n\n";
+  }
+
+  if (isset($conf_UAM['ADMINVALIDATIONMAIL']) and !empty($conf_UAM['ADMINVALIDATIONMAIL']))
   {
     // Management of Extension flags ([username], [mygallery], [myurl])
@@ -1863,7 +1863,7 @@
     if (function_exists('get_user_language_desc'))
     {
-      $custom_txt = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM[27]))."\n\n";
-    }
-    else $custom_txt = l10n(preg_replace($patterns, $replacements, $conf_UAM[27]))."\n\n";
+      $custom_txt = get_user_language_desc(preg_replace($patterns, $replacements, $conf_UAM['ADMINVALIDATIONMAIL']))."\n\n";
+    }
+    else $custom_txt = l10n(preg_replace($patterns, $replacements, $conf_UAM['ADMINVALIDATIONMAIL']))."\n\n";
   }
 
@@ -1952,7 +1952,7 @@
 WHERE user_id = '.$user_id.'
   AND (
-    group_id = '.$conf_UAM[2].'
+    group_id = '.$conf_UAM['NO_CONFIRM_GROUP'].'
   OR 
-    group_id = '.$conf_UAM[3].'
+    group_id = '.$conf_UAM['VALIDATED_GROUP'].'
   )
 ;';
@@ -1962,9 +1962,9 @@
     // Set user unvalidated status
     // ---------------------------
-    if (!is_admin() and $conf_UAM[7] <> -1)
+    if (!is_admin() and $conf_UAM['NO_CONFIRM_STATUS'] <> -1)
     {
       $query = '
 UPDATE '.USER_INFOS_TABLE.'
-SET status = "'.$conf_UAM[7].'"
+SET status = "'.$conf_UAM['NO_CONFIRM_STATUS'].'"
 WHERE user_id = '.$user_id.'
 ;';
@@ -1975,5 +1975,5 @@
     // Set user unvalidated group
     // --------------------------
-    if (!is_admin() and $conf_UAM[2] <> -1)
+    if (!is_admin() and $conf_UAM['NO_CONFIRM_GROUP'] <> -1)
     {
       $query = '
@@ -1981,5 +1981,5 @@
   (user_id, group_id)
 VALUES
-  ('.$user_id.', '.$conf_UAM[2].')
+  ('.$user_id.', '.$conf_UAM['NO_CONFIRM_GROUP'].')
 ;';
 
@@ -1989,9 +1989,9 @@
     // Set user unvalidated privacy level
     // ----------------------------------
-    if (!is_admin() and $conf_UAM[35] <> -1)
+    if (!is_admin() and $conf_UAM['NO_VALID_LEVEL'] <> -1)
     {
       $query = '
 UPDATE '.USER_INFOS_TABLE.'
-SET level = "'.$conf_UAM[35].'"
+SET level = "'.$conf_UAM['NO_VALID_LEVEL'].'"
 WHERE user_id = '.$user_id.'
 ;';
@@ -2035,7 +2035,7 @@
 WHERE user_id = '.$user_id.'
   AND (
-    group_id = '.$conf_UAM[2].'
+    group_id = '.$conf_UAM['NO_CONFIRM_GROUP'].'
   OR 
-    group_id = '.$conf_UAM[3].'
+    group_id = '.$conf_UAM['VALIDATED_GROUP'].'
   )
 ;';
@@ -2043,9 +2043,9 @@
   pwg_query($query);
 
-  if (!is_admin() and $conf_UAM[7] <> -1) // Set status
+  if (!is_admin() and $conf_UAM['NO_CONFIRM_STATUS'] <> -1) // Set status
   {
     $query = '
 UPDATE '.USER_INFOS_TABLE.'
-SET status = "'.$conf_UAM[7].'"
+SET status = "'.$conf_UAM['NO_CONFIRM_STATUS'].'"
 WHERE user_id = '.$user_id.'
 ;';
@@ -2054,5 +2054,5 @@
   }
 
-  if (!is_admin() and $conf_UAM[2] <> -1) // Set group
+  if (!is_admin() and $conf_UAM['NO_CONFIRM_GROUP'] <> -1) // Set group
   {
     $query = '
@@ -2060,5 +2060,5 @@
   (user_id, group_id)
 VALUES
-  ('.$user_id.', '.$conf_UAM[2].')
+  ('.$user_id.', '.$conf_UAM['NO_CONFIRM_GROUP'].')
 ;';
 
@@ -2066,5 +2066,5 @@
   }
 
-  if (!is_admin() and $conf_UAM[35] <> -1) // Set privacy level
+  if (!is_admin() and $conf_UAM['NO_VALID_LEVEL'] <> -1) // Set privacy level
   {
     $query = '
@@ -2072,5 +2072,5 @@
   (user_id, level)
 VALUES
-  ('.$user_id.', "'.$conf_UAM[35].'")
+  ('.$user_id.', "'.$conf_UAM['NO_VALID_LEVEL'].'")
 ;';
 
@@ -2261,5 +2261,5 @@
         // Verify Confirmmail with time limit ON
     		// -------------------------------------
-				if (isset ($conf_UAM_ConfirmMail[1]))
+				if (isset ($conf_UAM_ConfirmMail['CONFIRMMAIL_DELAY']))
         {
 				  // Dates formating and compare
@@ -2278,5 +2278,5 @@
 					// Condition with the value set for time limit
      			// -------------------------------------------
-					if ($deltadays <= $conf_UAM_ConfirmMail[1]) // If Nb of days is less than the limit set
+					if ($deltadays <= $conf_UAM_ConfirmMail['CONFIRMMAIL_DELAY']) // If Nb of days is less than the limit set
           {
             $dbnow = date("Y-m-d H:i:s");
@@ -2301,15 +2301,15 @@
 						pwg_query($query);
       
-						if ($conf_UAM[2] <> -1) // Delete user from unvalidated users group
+						if ($conf_UAM['NO_CONFIRM_GROUP'] <> -1) // Delete user from unvalidated users group
 						{
               $query = '
 DELETE FROM '.USER_GROUP_TABLE.'
 WHERE user_id = '.$data['user_id'].'
-  AND group_id = '.$conf_UAM[2].'
+  AND group_id = '.$conf_UAM['NO_CONFIRM_GROUP'].'
 ;';
 							pwg_query($query);
             }
 
-						if ($conf_UAM[3] <> -1) // Add user to validated users group 
+						if ($conf_UAM['VALIDATED_GROUP'] <> -1) // Add user to validated users group 
 						{
               $query = '
@@ -2317,14 +2317,14 @@
   (user_id, group_id)
 VALUES
-  ('.$data['user_id'].', '.$conf_UAM[3].')
+  ('.$data['user_id'].', '.$conf_UAM['VALIDATED_GROUP'].')
 ;';
 							pwg_query($query);
             }
 
-						if ($conf_UAM[4] <> -1) // Change user's status
+						if ($conf_UAM['VALIDATED_STATUS'] <> -1) // Change user's status
 						{
               $query = '
 UPDATE '.USER_INFOS_TABLE.'
-SET status = "'.$conf_UAM[4].'"
+SET status = "'.$conf_UAM['VALIDATED_STATUS'].'"
 WHERE user_id = '.$data['user_id'].'
 ;';
@@ -2332,9 +2332,9 @@
             }
 
-						if ($conf_UAM[36] <> -1) // Change user's privacy level
+						if ($conf_UAM['VALID_LEVEL'] <> -1) // Change user's privacy level
 						{
               $query = '
 UPDATE '.USER_INFOS_TABLE.'
-SET level = "'.$conf_UAM[36].'"
+SET level = "'.$conf_UAM['VALID_LEVEL'].'"
 WHERE user_id = '.$data['user_id'].'
 ;';
@@ -2356,5 +2356,5 @@
 						return true;
           }
-          elseif ($deltadays > $conf_UAM_ConfirmMail[1]) // If timelimit exeeds
+          elseif ($deltadays > $conf_UAM_ConfirmMail['CONFIRMMAIL_DELAY']) // If timelimit exeeds
           {
             return false;
@@ -2386,20 +2386,20 @@
           pwg_query($query);
 
-          if ($conf_UAM[2] <> -1) // Delete user from unvalidated users group
+          if ($conf_UAM['NO_CONFIRM_GROUP'] <> -1) // Delete user from unvalidated users group
           {
             $query = '
 DELETE FROM '.USER_GROUP_TABLE.'
 WHERE user_id = '.$data['user_id'].'
-AND group_id = '.$conf_UAM[2].'
+AND group_id = '.$conf_UAM['NO_CONFIRM_GROUP'].'
 ;';
             pwg_query($query);
           }
 
-          if ($conf_UAM[3] <> -1)
+          if ($conf_UAM['VALIDATED_GROUP'] <> -1)
           {
             $query = '
 DELETE FROM '.USER_GROUP_TABLE.'
 WHERE user_id = '.$data['user_id'].'
-AND group_id = '.$conf_UAM[3].'
+AND group_id = '.$conf_UAM['VALIDATED_GROUP'].'
 ;';
             pwg_query($query);
@@ -2409,14 +2409,14 @@
   (user_id, group_id)
 VALUES
-  ('.$data['user_id'].', '.$conf_UAM[3].')
+  ('.$data['user_id'].', '.$conf_UAM['VALIDATED_GROUP'].')
 ;';
             pwg_query($query);
           }
 
-          if ($conf_UAM[4] <> -1) // Change user's status
+          if ($conf_UAM['VALIDATED_STATUS'] <> -1) // Change user's status
           {
             $query = '
 UPDATE '.USER_INFOS_TABLE.'
-SET status = "'.$conf_UAM[4].'"
+SET status = "'.$conf_UAM['VALIDATED_STATUS'].'"
 WHERE user_id = '.$data['user_id'].'
 ;';
@@ -2424,9 +2424,9 @@
           }
 
-          if ($conf_UAM[36] <> -1) // Change user's privacy level
+          if ($conf_UAM['VALID_LEVEL'] <> -1) // Change user's privacy level
           {
             $query = '
 UPDATE '.USER_INFOS_TABLE.'
-SET level = "'.$conf_UAM[36].'"
+SET level = "'.$conf_UAM['VALID_LEVEL'].'"
 WHERE user_id = '.$data['user_id'].'
 ;';
@@ -2472,5 +2472,5 @@
 		$conf_UAM = unserialize($conf['UserAdvManager']);
 
-		if (isset($conf_UAM[1]) and $conf_UAM[1] == 'true') // Set date of validation
+		if (isset($conf_UAM['CONFIRM_MAIL']) and $conf_UAM['CONFIRM_MAIL'] == 'true') // Set date of validation
 		{
       $dbnow = date("Y-m-d H:i:s");
@@ -2484,20 +2484,20 @@
 		}
 
-		if ($conf_UAM[2] <> -1) // Delete user from waiting group
+		if ($conf_UAM['NO_CONFIRM_GROUP'] <> -1) // Delete user from waiting group
 		{
 				$query = '
 DELETE FROM '.USER_GROUP_TABLE.'
 WHERE user_id = '.$id.'
-		AND group_id = '.$conf_UAM[2].'
+		AND group_id = '.$conf_UAM['NO_CONFIRM_GROUP'].'
 ;';
 				pwg_query($query);
 		}
 
-		if ($conf_UAM[3] <> -1) // Set user's valid group
+		if ($conf_UAM['VALIDATED_GROUP'] <> -1) // Set user's valid group
 		{
       $query = '
 DELETE FROM '.USER_GROUP_TABLE.'
 WHERE user_id = '.$id.'
-		AND group_id = '.$conf_UAM[3].'
+		AND group_id = '.$conf_UAM['VALIDATED_GROUP'].'
 ;';
       pwg_query($query);
@@ -2507,14 +2507,14 @@
 		(user_id, group_id)
 VALUES
-		('.$id.', '.$conf_UAM[3].')
+		('.$id.', '.$conf_UAM['VALIDATED_GROUP'].')
 ;';
       pwg_query($query);
 		}
 
-		if ($conf_UAM[4] <> -1) // Set user's valid status
+		if ($conf_UAM['VALIDATED_STATUS'] <> -1) // Set user's valid status
 		{
       $query = '
 UPDATE '.USER_INFOS_TABLE.'
-SET status = "'.$conf_UAM[4].'"
+SET status = "'.$conf_UAM['VALIDATED_STATUS'].'"
 WHERE user_id = '.$id.'
 ;';
@@ -2522,9 +2522,9 @@
 		}
 
-		if ($conf_UAM[36] <> -1) // Set user's valid privacy level
+		if ($conf_UAM['VALID_LEVEL'] <> -1) // Set user's valid privacy level
 		{
       $query = '
 UPDATE '.USER_INFOS_TABLE.'
-SET level = "'.$conf_UAM[36].'"
+SET level = "'.$conf_UAM['VALID_LEVEL'].'"
 WHERE user_id = '.$id.'
 ;';
@@ -2556,7 +2556,7 @@
   $conf_UAM = unserialize($conf['UserAdvManager']);
 
-  if (isset($login) and isset($conf_UAM[6]) and !empty($conf_UAM[6]))
-  {
-    $conf_CharExclusion = preg_split("/,/",$conf_UAM[6]);
+  if (isset($login) and isset($conf_UAM['USERNAME_CHAR_LIST']) and !empty($conf_UAM['USERNAME_CHAR_LIST']))
+  {
+    $conf_CharExclusion = preg_split("/,/",$conf_UAM['USERNAME_CHAR_LIST']);
     for ($i = 0 ; $i < count($conf_CharExclusion) ; $i++)
     {
@@ -2615,7 +2615,7 @@
   $conf_UAM = unserialize($conf['UserAdvManager']);
 
-		if (isset($email) and isset($conf_UAM[11]) and !empty($conf_UAM[11]))
+		if (isset($email) and isset($conf_UAM['MAILEXCLUSION_LIST']) and !empty($conf_UAM['MAILEXCLUSION_LIST']))
 		{
-      $conf_MailExclusion = preg_split("/[\s,]+/",$conf_UAM[11]);
+      $conf_MailExclusion = preg_split("/[\s,]+/",$conf_UAM['MAILEXCLUSION_LIST']);
       for ($i = 0 ; $i < count($conf_MailExclusion) ; $i++)
       {
@@ -2669,6 +2669,6 @@
     ON u.'.$conf['user_fields']['id'].' = ug.user_id
 WHERE u.'.$conf['user_fields']['id'].' >= 3
-  AND (TO_DAYS(NOW()) - TO_DAYS(ui.registration_date) >= "'.$conf_UAM_ConfirmMail[1].'"
-  OR TO_DAYS(NOW()) - TO_DAYS(ui.registration_date) < "'.$conf_UAM_ConfirmMail[1].'")
+  AND (TO_DAYS(NOW()) - TO_DAYS(ui.registration_date) >= "'.$conf_UAM_ConfirmMail['CONFIRMMAIL_DELAY'].'"
+  OR TO_DAYS(NOW()) - TO_DAYS(ui.registration_date) < "'.$conf_UAM_ConfirmMail['CONFIRMMAIL_DELAY'].'")
 		AND u.UAM_validated = "false"
 ORDER BY ui.registration_date ASC
@@ -2744,5 +2744,5 @@
     ON u.'.$conf['user_fields']['id'].' = ui.user_id
 WHERE u.'.$conf['user_fields']['id'].' >= 3
-  AND (TO_DAYS(NOW()) - TO_DAYS(ui.registration_date) >= "'.$conf_UAM_ConfirmMail[1].'")
+  AND (TO_DAYS(NOW()) - TO_DAYS(ui.registration_date) >= "'.$conf_UAM_ConfirmMail['CONFIRMMAIL_DELAY'].'")
 ORDER BY ui.registration_date ASC;';
 
@@ -2783,5 +2783,5 @@
   INNER JOIN '.USER_LASTVISIT_TABLE.' AS lv
     ON u.'.$conf['user_fields']['id'].' = lv.user_id
-WHERE (TO_DAYS(NOW()) - TO_DAYS(lv.lastvisit) >= "'.$conf_UAM[16].'")
+WHERE (TO_DAYS(NOW()) - TO_DAYS(lv.lastvisit) >= "'.$conf_UAM['GHOSTRACKER_DAYLIMIT'].'")
 ORDER BY lv.lastvisit ASC;';
 
@@ -2830,5 +2830,5 @@
   INNER JOIN '.USER_LASTVISIT_TABLE.' AS lv
     ON u.'.$conf['user_fields']['id'].' = lv.user_id
-WHERE (TO_DAYS(NOW()) - TO_DAYS(lv.lastvisit) >= "'.$conf_UAM[16].'")
+WHERE (TO_DAYS(NOW()) - TO_DAYS(lv.lastvisit) >= "'.$conf_UAM['GHOSTRACKER_DAYLIMIT'].'")
 ORDER BY lv.lastvisit ASC;';
 
@@ -2940,5 +2940,5 @@
     // Condition with the value set for time limit
     // -------------------------------------------
-    if ($deltadays <= $conf_UAM_ConfirmMail[1]) // If Nb of days is less than the limit set
+    if ($deltadays <= $conf_UAM_ConfirmMail['CONFIRMMAIL_DELAY']) // If Nb of days is less than the limit set
     {
       return false;
@@ -3200,5 +3200,5 @@
     $result = pwg_query($query);
 
-    while ($row = mysql_fetch_array($result))
+    while ($row = pwg_db_fetch_assoc($result))
     {
       if ($row['UAM_pwdreset'] == 'false')
@@ -3264,11 +3264,13 @@
       $insertions .= "DROP TABLE IF EXISTS ".$ListTables[$j].";\n\n";
 
-      $array = mysql_fetch_array($res);
+      $array = pwg_db_fetch_row($res);
       $array[1] .= ";\n\n";
       $insertions .= $array[1];
 
-      $req_table = pwg_query('SELECT * FROM '.$ListTables[$j]) or die(mysql_error());
-      $nb_fields = mysql_num_fields($req_table);
-      while ($line = mysql_fetch_array($req_table))
+      $req_table = pwg_query('DESCRIBE '.$ListTables[$j].';') or die(my_error());
+      $nb_fields = pwg_db_num_rows($req_table);
+      $req_table2 = pwg_query('SELECT * FROM '.$ListTables[$j]) or die(my_error());
+
+      while ($line = pwg_db_fetch_row($req_table2))
       {
         $insertions .= 'INSERT INTO '.$ListTables[$j].' VALUES (';
@@ -3296,8 +3298,9 @@
 
   $pattern = "UserAdvManager%";
-  $req_table = pwg_query('SELECT * FROM '.CONFIG_TABLE.' WHERE param LIKE "'.$pattern.'";') or die(mysql_error());
-  $nb_fields = mysql_num_fields($req_table);
-
-  while ($line = mysql_fetch_array($req_table))
+  $req_table = pwg_query('SELECT * FROM '.CONFIG_TABLE.' WHERE param LIKE "'.$pattern.'";') or die(my_error());
+  $nb_fields = pwg_db_num_rows($req_table);
+  $nb_fields = $nb_fields - 1;  // Fix the number of fields because pwg_db_num_rows() returns a bad number
+
+  while ($line = pwg_db_fetch_row($req_table))
   {
     $insertions = 'INSERT INTO '.CONFIG_TABLE.' VALUES (';
Index: /extensions/UserAdvManager/trunk/include/upgradedb.inc.php
===================================================================
--- /extensions/UserAdvManager/trunk/include/upgradedb.inc.php	(revision 21074)
+++ /extensions/UserAdvManager/trunk/include/upgradedb.inc.php	(revision 21075)
@@ -685,5 +685,5 @@
 		$result = pwg_query($query);
 
-		while($row = mysql_fetch_array($result))
+		while($row = pwg_db_fetch_assoc($result))
 		{
 				$query = '
@@ -703,3 +703,105 @@
 		pwg_query($query);
 }
+
+
+/* upgrade from 2.41.x to 2.50.0 */
+/* ***************************** */
+function upgrade_2410_2500()
+{
+  global $conf;
+  
+  load_language('plugin.lang', UAM_PATH);
+
+  // Upgrading options - Changing config variables to assoc array
+  // ------------------------------------------------------------
+  
+  // Upgrade $conf_UAM options
+  $conf_UAM = unserialize($conf['UserAdvManager']);
+
+  $Newconf_UAM = array(
+    'MAIL_INFO'                   => $conf_UAM[0],
+    'CONFIRM_MAIL'                => $conf_UAM[1],
+    'NO_CONFIRM_GROUP'            => $conf_UAM[2],
+    'VALIDATED_GROUP'             => $conf_UAM[3],
+    'VALIDATED_STATUS'            => $conf_UAM[4],
+    'USERNAME_CHAR'               => $conf_UAM[5],
+    'USERNAME_CHAR_LIST'          => $conf_UAM[6],
+    'NO_CONFIRM_STATUS'           => $conf_UAM[7],
+    'MAILINFO_TEXT'               => $conf_UAM[8],
+    'CONFIRMMAIL_TEXT'            => $conf_UAM[9],
+    'MAILEXCLUSION'               => $conf_UAM[10],
+    'MAILEXCLUSION_LIST'          => $conf_UAM[11],
+    'PASSWORDENF'                 => $conf_UAM[12],
+    'PASSWORD_SCORE'              => $conf_UAM[13],
+    'ADMINPASSWENF'               => $conf_UAM[14],
+    'GHOSTRACKER'                 => $conf_UAM[15],
+    'GHOSTRACKER_DAYLIMIT'        => $conf_UAM[16],
+    'GHOSTRACKER_REMINDERTEXT'    => $conf_UAM[17],
+    'ADDLASTVISIT'                => $conf_UAM[18],
+    'ADMINCONFMAIL'               => $conf_UAM[19],
+    'REDIRTOPROFILE'              => $conf_UAM[20],
+    'GTAUTO'                      => $conf_UAM[21],
+    'GTAUTOMAIL'                  => $conf_UAM[22],
+    'GTAUTODEL'                   => $conf_UAM[23],
+    'GTAUTOMAILTEXT'              => $conf_UAM[24],
+    'DOWNGRADE_GROUP'             => $conf_UAM[25],
+    'DOWNGRADE_STATUS'            => $conf_UAM[26],
+    'ADMINVALIDATIONMAIL'         => $conf_UAM[27],
+    'CUSTOMPASSWRETR'             => $conf_UAM[28],
+    'CUSTOMPASSWRETR_TEXT'        => $conf_UAM[29],
+    'USRAUTO'                     => $conf_UAM[30],
+    'USRAUTODEL'                  => $conf_UAM[31],
+    'USRAUTOMAIL'                 => $conf_UAM[32],
+    'STUFFS'                      => $conf_UAM[33],
+    'HIDEPASSW'                   => $conf_UAM[34],
+    'NO_VALID_LEVEL'              => $conf_UAM[35],
+    'VALID_LEVEL'                 => $conf_UAM[36],
+    'DOWNGRADE_LEVEL'             => $conf_UAM[37],
+    'PWDRESET'                    => $conf_UAM[38],
+    'REJECTCONNECT'               => $conf_UAM[39],
+    'REJECTCONNECT_TEXT'          => $conf_UAM[40],
+    'CONFIRMMAIL_SUBJECT'         => $conf_UAM[41],
+    'CONFIRMMAIL_REMAIL_SUBJECT'  => $conf_UAM[42],
+    'INFOMAIL_SUBJECT'            => $conf_UAM[43],
+    'GTAUTOMAIL_SUBJECT'          => $conf_UAM[44],
+    'GTREMINDER_SUBJECT'          => $conf_UAM[45],
+    'ADMINVALIDATIONMAIL_SUBJECT' => $conf_UAM[46]
+  );
+
+  // unset obsolete conf
+  // -------------------
+  for ($i = 0; $i <= 46; $i++)
+  {
+    unset ($conf_UAM[$i]);
+  }
+
+  $update_conf = serialize($Newconf_UAM);
+
+  conf_update_param('UserAdvManager', pwg_db_real_escape_string($update_conf));
+
+
+  // Upgrade $conf_UAM_ConfirmMail
+  $conf_UAM_ConfirmMail = unserialize($conf['UserAdvManager_ConfirmMail']);
+
+  $Newconf_UAM_ConfirmMail = array (
+    'CONFIRMMAIL_TIMEOUT'     => $conf_UAM_ConfirmMail[0],
+    'CONFIRMMAIL_DELAY'       => $conf_UAM_ConfirmMail[1],
+    'CONFIRMMAIL_REMAIL_TXT1' => $conf_UAM_ConfirmMail[2],
+    'CONFIRMMAIL_REMAIL'      => $conf_UAM_ConfirmMail[3],
+    'CONFIRMMAIL_REMAIL_TXT2' => $conf_UAM_ConfirmMail[4],
+    'CONFIRMMAIL_CUSTOM_TXT1' => $conf_UAM_ConfirmMail[5],
+    'CONFIRMMAIL_CUSTOM_TXT2' => $conf_UAM_ConfirmMail[6]
+  );
+
+  // unset obsolete conf
+  // -------------------
+  for ($i = 0; $i <= 6; $i++)
+  {
+    unset ($conf_UAM_ConfirmMail[$i]);
+  }
+
+  $update_conf = serialize($Newconf_UAM_ConfirmMail);
+
+  conf_update_param('UserAdvManager_ConfirmMail', pwg_db_real_escape_string($update_conf));
+}
 ?>
Index: /extensions/UserAdvManager/trunk/language/fr_FR/plugin.lang.php
===================================================================
--- /extensions/UserAdvManager/trunk/language/fr_FR/plugin.lang.php	(revision 21074)
+++ /extensions/UserAdvManager/trunk/language/fr_FR/plugin.lang.php	(revision 21075)
@@ -16,6 +16,6 @@
 $lang['UAM_Err_audit_username_char'] = '<b>Ce compte contient un ou des caractères interdits :</b> ';
 $lang['UAM_Err_audit_email_forbidden'] = '<b>Ce compte contient des domaines de messagerie interdit :</b> ';
-$lang['UAM_Err_audit_advise'] = '<b>Vous avez des corrections a faire pour respecter les nouvelles règles que vous avez activées.<br>Utilisez un utilitaire de gestion de base de données pour corriger les comptes utilisateurs directement dans la table ###_USERS si nécessaire.</b><br><br>';
-$lang['UAM_reg_err_login2'] = 'le nom utilisateur ne doit pas contenir les caractère suivants : ';
+$lang['UAM_Err_audit_advise'] = '<b>Vous avez des corrections à faire pour respecter les nouvelles règles que vous avez activées.<br>Utilisez un utilitaire de gestion de base de données pour corriger les comptes utilisateurs directement dans la table ###_USERS si nécessaire.</b><br><br>';
+$lang['UAM_reg_err_login2'] = 'le nom utilisateur ne doit pas contenir les caractères suivants : ';
 $lang['UAM_reg_err_login5'] = 'L\'adresse email est issue d\'un prestataire interdit. Les prestataires d\'adresses email interdits à l\'inscription sont : ';
 $lang['UAM_empty_pwd'] = '[mot de passe vide]';
Index: /extensions/UserAdvManager/trunk/main.inc.php
===================================================================
--- /extensions/UserAdvManager/trunk/main.inc.php	(revision 21074)
+++ /extensions/UserAdvManager/trunk/main.inc.php	(revision 21075)
@@ -69,5 +69,5 @@
 // PWG_Stuffs module
 // -----------------
-if (isset($conf_UAM[33]) and $conf_UAM[33] == 'true')
+if (isset($conf_UAM['STUFFS']) and $conf_UAM['STUFFS'] == 'true')
 {
   add_event_handler('get_stuffs_modules', 'register_UAM_stuffs_module');
@@ -76,5 +76,5 @@
 // Add new feature in user_list - Password Reset
 // ---------------------------------------------
-if (isset($conf_UAM[38]) and $conf_UAM[38] == 'true')
+if (isset($conf_UAM['PWDRESET']) and $conf_UAM['PWDRESET'] == 'true')
 {
   // Add new column on user_list
